<template>
	<button class="ui-button" v-on="$listeners" :class="[classList, customClasses]" :disabled="disabled">
		<slot></slot>
	</button>
</template>

<script>
	export default {
		name: 'ui-component-button',
		props: {
			customClasses: [ String, Function],
			block: {
				type: Boolean,
				default: false,
			},

			disabled: {
				type: Boolean,
				default: false
			},

			underline: {
				type: Boolean,
				default: false
			},

			center: {
				type: Boolean,
				default: false,
			},

			link: {
				type: Boolean,
				default: false,
			},

			bold: {
				type: Boolean,
				default: false,
			},

			color: {
				type: String,
				default: 'blue'
			}
		},

		computed: {
			classList () {
				const list = [];
				if (this.color) list.push(`ui-button__color-${this.color}`);
				if (this.block) list.push('ui-button__block');
				if (this.center) list.push('ui-button__center');
				if (this.link) list.push('ui-button__link');
				if (this.bold) list.push('ui-button__bold');
				if (this.underline) list.push('ui-button__underline');
				if (this.disabled) list.push('ui-button__disabled');
				return list;
			}
		}
	};
</script>
